#include <iostream>
#include <sstream>
#include <string>

template <class T>
class Exemplo
{
public:
  Exemplo();
  T& getProduto();
  void setProduto(const T &produto);
  void imprimeNomeObjeto();

private:
  T _produto;
  static int _indice;
  std::string _nome;
};

template <class T>
int Exemplo<T>::_indice = 0;

template <class T>
Exemplo<T>::Exemplo()
{
  _indice++;
  _nome = "Objeto ";
  std::ostringstream ostr;
  ostr << _indice;
  _nome += ostr.str();
}

template <class T>
T& Exemplo<T>::getProduto()
{
  return _produto;
}

template <class T>
void Exemplo<T>::setProduto(const T &produto)
{
  _produto = produto;
}

template <class T>
void Exemplo<T>::imprimeNomeObjeto()
{
  std::cout << "Consultando nome: " << _nome << std::endl;
}
